package controller;

import gui.Resources;

import java.awt.event.ActionEvent;

import javax.swing.JOptionPane;

import model.ModelImplementation;
import model.ModelInterface;
import model.Note;

public class DeleteOptionPaneAction extends AbstractNoteAction{

	private Note myNote;


	public DeleteOptionPaneAction() {
		super("deleteOptionPane");

	}

	public void saveNoteRef(Note myNote){
		this.myNote = myNote;
	}


	public void actionPerformed(ActionEvent e) {

		JOptionPane opConfirmDelete = new JOptionPane();
		int result = setMessageInOptionPane(opConfirmDelete);


//		System.out.println("Weiterleitung an Model von DeleteOptionPaneAction");

		if(result == 0){
			//Version loeschen
			deleteNoteVersion(false);
		}
		else if(result == 1){
			//Notiz loeschen
			deleteNoteVersion(true);
		}
	}

	private void deleteNoteVersion(boolean isVersionDeleting) {
		ModelInterface model = ModelImplementation.getInstance();
		JOptionPane opShowResultOfDeleting = new JOptionPane();

		if(model.deleteNote(myNote,isVersionDeleting)){
			opShowResultOfDeleting.showMessageDialog(null, getMessageString(isVersionDeleting, true));
		}else{
			opShowResultOfDeleting.showMessageDialog(null, getMessageString(isVersionDeleting, true));
		}
	}

	private String getMessageString(boolean isVersionDeleting, boolean isNoneError) {
		String message = "";
		if (!isNoneError) {
			message += Resources.getString("OptionPane.deleteError");
		}
		
		if (isVersionDeleting) {
			message += " "+ Resources.getString("OptionPane.deleteNote");
		}
		else {
			message += " "+ Resources.getString("OptionPane.deleteVersion");
		}
		
		if (isNoneError) {
			message += " "+ Resources.getString("OptionPane.deleteNoteVersion");
		}
		else {
			message += " !";
		}
		
		return message;
	}

	private int setMessageInOptionPane(JOptionPane myOptionPane) {
		int result = myOptionPane.showOptionDialog(null, "" +
				Resources.getString("note")+":\n" +
				"\n"+ Resources.getString("title") +": "+ myNote.getTitle() +
				"\n"+ Resources.getString("keywords") +": "+ myNote.getKeyword() +
				"\n"+ Resources.getString("changeDate") +": "+ myNote.getDate() +
				"\n"+ Resources.getString("author") +": "+ myNote.getAuthor() +
				"\n\n"+ Resources.getString("OptionPane.deleteNoteQuestion"), Resources.getString("OptionPane.title"), JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, null, new String[]{ Resources.getString("OptionPane.dV"), Resources.getString("OptionPane.NV"), Resources.getString("OptionPane.CANCEL")}, null);
		return result;
	}
}
