package controller;

import gui.CreateSaveInterface;

import java.awt.event.ActionEvent;
import java.util.ResourceBundle;

import javax.swing.JOptionPane;

import model.ModelImplementation;
import model.ModelInterface;
import model.Note;

public class SaveAction extends AbstractNoteAction{
	
	static ResourceBundle rb = ResourceBundle.getBundle("gui.ResourcesNotemanager");
	
	CreateSaveInterface csi;

	public SaveAction(){
		super("save");
	}
	
	public void setCreateSaveInterface(CreateSaveInterface createSave){
		csi = createSave;
	}
	
	public void actionPerformed(ActionEvent ae) {
		getNoteData();
		ModelInterface model = ModelImplementation.getInstance();
		saveActionMessage(model);
	}

	public void saveActionMessage(ModelInterface model) {
		JOptionPane myOptionPane = new JOptionPane();
		if(model.saveNote(csi.getNoteVersion())){
			myOptionPane.showMessageDialog(null, rb.getString("savemessage"));
		}else{
			myOptionPane.showMessageDialog(null, rb.getString("errorsavemessage"));
		}
	}
	
	public Note getNoteData() {
		Note nv = csi.getNoteVersion();
		nv.setTitle(csi.getTitle());
		nv.setFullText(csi.getNote());
		nv.setAuthor(csi.getAuthor());
		nv.setVersionID(nv.getVersionID() + 1);
		return nv;
	}

}
