package controller;

import gui.CreateSaveInterface;
import gui.MainGuiFrame;
import gui.SearchResultNote;

import java.awt.event.ActionEvent;

import model.ModelImplementation;
import model.ModelInterface;
import model.SearchCriteria;

public class SearchAction extends AbstractNoteAction{

	private MainGuiFrame mainGui;
	CreateSaveInterface csi;

	public SearchAction(){
		super("search", true);
	}

	public void setCreateSaveInterface(CreateSaveInterface createSave){
		csi = createSave;
	}

	public void actionPerformed(ActionEvent ae) {
//		System.out.println("Button Search geklickt");

		SearchCriteria sc = new SearchCriteria();
		copyProperties(sc);

		ModelInterface model = ModelImplementation.getInstance();
//		System.out.println("Weiterleitung an Model von SearchAction");
		new SearchResultNote(mainGui, sc, model.searchNote(sc));
		//TODO SearchAction Weiterleitung auf SearchResultNote
	}

	private void copyProperties(SearchCriteria sc) {
		sc.setTitle(csi.getTitle());
		sc.setKeyword(csi.getKeyword());
		sc.setAuthor(csi.getAuthor());
		sc.setFullText(csi.getNote());
		sc.setDateFrom(csi.getDateFrom());
		sc.setDateTo(csi.getDateTo());
	}

	public void setMainGuiReference(MainGuiFrame mainGui) {

		this.mainGui = mainGui;
	}

}
