package gui;

import java.awt.BorderLayout;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.TableModel;

import model.Note;
import model.SearchCriteria;
import controller.ActionMap;
import controller.DeleteFromTableAction;
import controller.OpenAction;

public class SearchResultNote extends TabContent {

	MainGuiFrame mainGui;
	OpenAction openAction = (OpenAction) ActionMap.getAction("open");
	DeleteFromTableAction deleteAction = (DeleteFromTableAction) ActionMap.getAction("deleteFromTable");
	JButton openButton = new JButton(openAction);
	JButton deleteButton = new JButton(deleteAction);
	JTable resultTable = new JTable();
	TableModel tableModel;
	ArrayList selectedLines = new ArrayList();
	ArrayList convertetArrayList = null;
	Collection inputCollection;
	SearchCriteria searchCriteria;

	public SearchResultNote(MainGuiFrame refMainGui, SearchCriteria sc, Collection resultCollection){
		inputCollection = resultCollection;
		mainGui = refMainGui;
		searchCriteria = sc;
		
		configureButtonAndAction();

		resultTable.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				checkSelection(e);
			}
		});

		designLayout(resultCollection);
	}

	private void configureButtonAndAction() {
		openButton.setEnabled(false);
		deleteButton.setEnabled(false);
//		System.out.println("Inhalt openAction "+ openAction);
		openAction.setSearchResultNoteReference(this);
		deleteAction.setSearchResultNoteReference(this);
	}

	private void designLayout(Collection resultCollection) {
		this.setLayout(new BorderLayout(10,10));

		JPanel resultPanel = new JPanel();
		designPanel(resultPanel);
		add(resultPanel, BorderLayout.CENTER);

		updateModel(resultCollection);

		addButton(openButton);
		addButton(deleteButton);

		mainGui.addNewTab(this);
	}

	private void designPanel(JPanel testPanel) {
		testPanel.setLayout(new BorderLayout());
		testPanel.add(new JScrollPane(resultTable), BorderLayout.CENTER);
		testPanel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
	}

	private void checkSelection(ListSelectionEvent e) {
		ListSelectionModel lsm = (ListSelectionModel) e.getSource();
		boolean isEmpty = lsm.isSelectionEmpty();
		openButton.setEnabled(!isEmpty);
		deleteButton.setEnabled(!isEmpty);

		selectedLines = new ArrayList();

		for(int p = 0; p < convertetArrayList.size() ;p++){
			if(lsm.isSelectedIndex(p)){										
				selectedLines.add(p);
			}
		}
	}	
	
	public void updateModel(Collection resultCollection) {
		convertetArrayList = new ArrayList(resultCollection);
			
		setTabName(Resources.getString("searchResult") 
				+": "+ convertetArrayList.size() +" " 
				+ Resources.getString("searchResult.hits"));
		
		tableModel = new SearchResultNote_TableModel(convertetArrayList);
		resultTable.setModel(tableModel);
	}

	public int smallLines() {
		return 1;
	}

	public Note getNoteVersionObject(int myIndex) {
		Iterator iterator = inputCollection.iterator();
		Note myNoteVersion;
		for(int i = 0; iterator.hasNext(); i++){
			myNoteVersion = (Note) iterator.next();
			if(i == myIndex){
				return myNoteVersion;
			}
		} 
		return null;
	}

	public ArrayList getIndexes() {
		return selectedLines;
	}

	public MainGuiFrame getMainGuiReference() {
		return mainGui;
	}
	
	public SearchCriteria getSearchCriteria() {
		return searchCriteria;
	}
}