/*
 * Created on 24.10.2007
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gui;

import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.util.Collection;
import java.util.Date;
import java.util.ResourceBundle;

import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import model.Note;

import controller.CreateAction;
import controller.DeleteOptionPaneAction;
import controller.EditAction;
import controller.ActionMap;

public class ShowNote extends TabContent{
			
	JLabel lNote = new JLabel(rb.getString("notetext"));
	JLabel lAuthor = new JLabel(rb.getString("author"));
	JLabel lVersion = new JLabel(rb.getString("version"));
	JLabel lCreate = new JLabel(rb.getString("createDate"));

	JTextField tfCategory = new JTextField(20);
	JTextField tfAuthor = new JTextField(20);
	JTextField tfVersion = new JTextField(20);
	JTextField tfCreate = new JTextField(20);
	
	JButton editButton;
	JButton deleteButton;
	
	public ShowNote(MainGuiFrame refMainGui, Note refNote){
		super(refMainGui, refNote);
				
		setContent();
		
		setTabName(refNote.getTitle());
		
		setComponentLayout();
		
		creatButtonsForShowNote();
		
		setEditable();
		
		mainGui.addNewTab(this);
	}

	public void creatButtonsForShowNote() {
		EditAction ea = createAndRegisterEditAction();
		DeleteOptionPaneAction dfva = createAndRegisterDeleteAction();
		
		editButton = new JButton(ea);
		deleteButton = new JButton(dfva);
		
		addButton(editButton);
		addButton(deleteButton);
	}

	public DeleteOptionPaneAction createAndRegisterDeleteAction() {
		Action deleteAction = ActionMap.getAction("deleteOptionPane");
		DeleteOptionPaneAction dfva = (DeleteOptionPaneAction) deleteAction;
		dfva.saveNoteRef(note);
		return dfva;
	}

	public EditAction createAndRegisterEditAction() {
		Action action = ActionMap.getAction("edit");
		EditAction ea = (EditAction) action;
		ea.setMainGuiReference(mainGui);
		ea.setTabContentReference(this);
		ea.setNoteReference(note);
		return ea;
	}

	public void setComponentLayout() {
		constraints.anchor = GridBagConstraints.NORTHWEST;
		setComponent(constraints, 0, 0, 1, 1, lTitle);		
		setComponent(constraints, 1, 0, 1, 1, lCategory);		
		setComponent(constraints, 2, 0, 1, 1, lCreate);
		setComponent(constraints, 0, 2, 1, 1, lAuthor);
		setComponent(constraints, 1, 2, 1, 1, lVersion);
		setComponent(constraints, 0, 4, 1, 1, lNote);
		
		setComponent(constraints, 0, 1, 1, 1, tfTitle);
		setComponent(constraints, 1, 1, 1, 1, tfCategory);
		setComponent(constraints, 2, 1, 1, 1, tfCreate);
		setComponent(constraints, 0, 3, 1, 1, tfAuthor);
		setComponent(constraints, 1, 3, 1, 1, tfVersion);
		
		constraints.fill = GridBagConstraints.BOTH;
		setComponent(constraints, 0, 5, 1, 2, taNote);
	}

	public void setEditable() {
		taNote.setEditable(false);
		tfTitle.setEditable(false);
		tfCategory.setEditable(false);
		tfAuthor.setEditable(false);
		tfVersion.setEditable(false);
		tfCreate.setEditable(false);
	}

	public void setContent() {
		tfTitle.setText(note.getTitle());
		
		Collection categories = note.getCategories();
		String category = "" + categories;
		tfCategory.setText(category);	
		
		tfAuthor.setText(note.getAuthor());
		
		int versId = note.getVersionID();
		String versionId = "" + versId;
		tfVersion.setText(versionId);
		
		Date cDate = note.getDate();
		String createDate = "" + cDate;
		tfCreate.setText(createDate);
		
		taNote.setText(note.getFullText());
	}

	public int smallLines() {
		return 5;
	}
}
