package gui;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.util.ArrayList;
import java.util.Collection;
import java.util.ResourceBundle;

import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import model.Category;
import model.ModelImplementation;
import model.ModelInterface;
import model.Note;

import controller.ActionMap;

public abstract class TabContent extends JPanel {
	
	static ResourceBundle rb = ResourceBundle.getBundle("gui.ResourcesNotemanager");
	
	protected MainGuiFrame mainGui;
	protected Note note;
	
	protected JLabel lTitle = new JLabel(rb.getString("title"));
	protected JLabel lCategory = new JLabel(rb.getString("category"));
	
	protected JTextField tfTitle = new JTextField(20);
	protected JTextArea taNote = new JTextArea(1, 1);
	
	protected CategoryPanel spCategory;
	
	protected GridBagConstraints constraints;
	
	public TabContent(){
		
	}
	
	public TabContent(MainGuiFrame refMainGui){
		this(refMainGui, null);
	}
	
	public TabContent(MainGuiFrame refMainGui, Note refNote){
		mainGui = refMainGui;
		note = refNote;
		
		this.setLayout(new GridBagLayout());
		
		createAndSetGridBagConstraints();
	}

	public void createAndSetGridBagConstraints() {
		constraints = new GridBagConstraints();
		constraints.insets = new Insets(5, 5, 5, 5);
		constraints.fill = GridBagConstraints.HORIZONTAL;
		constraints.weightx = 1.0;
		constraints.weighty = 1.0;
	}
	
	public void createCategoryPanel(){
		ModelInterface mi = ModelImplementation.getInstance();
		Category root = mi.getRootCategory();
		spCategory = new CategoryPanel(root);
	}
	
	private Collection buttons = new ArrayList(); 
	String tabName = null;
	
	public Collection getButtons() {
		return buttons;	
	}
	
	public void addButton(JButton button) {
		buttons.add(button);
	}
	
	public void createAddButton(String actionname) {
		Action action = ActionMap.getAction(actionname);
		JButton button = new JButton(action);
		addButton(button);
	}
	
	public void setTabName(String name) {
		tabName = name;
	}
	public String getTabName() {
		return tabName;
	}
	
	public void setComponent(GridBagConstraints c, int gridx, int gridy, int gridheight, int gridwidth, JComponent comp){
		c.gridx = gridx;
		c.gridy = gridy;
		c.gridheight = gridheight;
		c.gridwidth = gridwidth;
		
		if(gridy < smallLines())
			c.weighty = 0.0;
		else
			c.weighty = 1.0;
		
		this.add(comp, c);
	}
	
	public abstract int smallLines();
}