package sql;

import java.sql.Connection;
import java.sql.Driver;
import java.sql.DriverManager;
import java.util.*;


public class DBConnectionManager {

	static ResourceBundle rb =  ResourceBundle.getBundle("sql.DBServer");

	private static final DBConnectionManager INSTANCE = new DBConnectionManager();

	private Hashtable pools;
	private String connectionString = "jdbc:mysql://" + rb.getString("DBIP") + 
	"/" + rb.getString("dbName");	

	private DBConnectionManager(){

//		load and register driver
		try {
			Class.forName("com.mysql.jdbc.Driver").newInstance();
		} catch (Exception ex) {
			System.out.println("Fehler: " + ex.getMessage());
		}

		pools = new Hashtable();
		System.out.println(connectionString);
		//System.out.println(rb.getString("DBIP"));
		pools.put("db_notizverwaltung", 
				new DBConnectionPool(10,"user","123456",true, connectionString));	
	}


	public static DBConnectionManager getInstance(){
		return INSTANCE;
	}

	public Connection getConnection(String pool){

		Connection c = null;		
		c =((DBConnectionPool) pools.get(pool)).getConnection();
		return c;
	}

	public void putConnection(String pool, Connection con){
		
		((DBConnectionPool) pools.get(pool)).putConnection(con);
		
	}

}


