package sql;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;

import model.Note;
import model.SearchCriteria;

public class SearchDAO extends DAO{


	String query = "SELECT * FROM user, noteversion WHERE UserID = Author ";

	public Collection searchNote(SearchCriteria sc) {
		
		try{	
			stmt = createStatementSearch(sc, c);
			ResultSet dbResult = stmt.executeQuery(query);
			Collection searchResult = new ArrayList();

			while(dbResult.next()){
				fillSearchResult(dbResult, searchResult);
			}
			lastCommitState(c);
			return searchResult;
		}
		catch(SQLException ex){
			errorQuery(c, ex);
			return null;
		}
		finally{
			ref.putConnection("db_notizverwaltung", c);
		}
	}

	private void fillSearchResult(ResultSet dbResult, Collection searchResult) throws SQLException {
		Note nv = new Note();
		nv.setAuthor(dbResult.getString("Nickname"));
		nv.setTitle(dbResult.getString("Title"));
		nv.setDate(dbResult.getDate("Date"));
		nv.setFullText(dbResult.getString("Text"));
		nv.setKeyword(dbResult.getString("Keyword"));
		nv.setVersionID(dbResult.getInt("VersionID"));
		//NoteID ist DBID
		nv.setDBID(dbResult.getInt("NoteID"));
		searchResult.add(nv);
	}

	private Statement createStatementSearch(SearchCriteria sc, Connection c) throws SQLException {
		Statement stmt;
	
		addTerm(sc.getAuthor(), "user.Nickname LIKE", true);
		addTerm(SaveDAO.formatDate(sc.getDateFrom()), "Date > ");
		addTerm(SaveDAO.formatDate(sc.getDateTo()), "Date < ");
		addTerm(sc.getFullText(), "Text LIKE ", true);
		addTerm(sc.getKeyword(), "Keyword LIKE ", true);
		addTerm(sc.getTitle(), "Title LIKE ", true);
		

		stmt = c.createStatement();
		return stmt;
	}

	private void addTerm(Object term, String queryDiff){
		if(null != term && term.toString().length() > 0){
			query += " AND ";
			query += queryDiff + " " + "\"" + term.toString() + "\"";
		}
	}
	
	private void addTerm(Object term, String queryDiff, boolean addLIKE){
		if(null != term){
			addTerm(term.toString().replace('*', '%'), queryDiff);
		}
	}

	public static void main(String[] args) {
		SearchCriteria sc = new SearchCriteria();
		sc.setAuthor("fi*");
		new SearchDAO().searchNote(sc);

	}

}

